package com.zt.plat.module.qms.resource.record.service.recordcategory;

import java.util.*;

import com.zt.plat.module.qms.resource.record.controller.admin.recordcategory.vo.RecordCategoryPageReqVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordcategory.vo.RecordCategoryRespVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordcategory.vo.RecordCategorySaveReqVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordrecord.vo.RecordRecordRespVO;
import jakarta.validation.*;
import com.zt.plat.module.qms.resource.record.dal.dataobject.recordcategory.RecordCategoryDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 文件记录分类 Service 接口
 *
 * @author 后台管理
 */
public interface RecordCategoryService {

    /**
     * 创建文件记录分类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    RecordCategoryRespVO createRecordCategory(@Valid RecordCategorySaveReqVO createReqVO);

    /**
     * 更新文件记录分类
     *
     * @param updateReqVO 更新信息
     */
    void updateRecordCategory(@Valid RecordCategorySaveReqVO updateReqVO);

    /**
     * 删除文件记录分类
     *
     * @param id 编号
     */
    void deleteRecordCategory(Long id);

    /**
    * 批量删除文件记录分类
    *
    * @param ids 编号
    */
    void deleteRecordCategoryListByIds(List<Long> ids);

    /**
     * 获得文件记录分类
     *
     * @param id 编号
     * @return 文件记录分类
     */
    RecordCategoryDO getRecordCategory(Long id);

    /**
     * 获得文件记录分类分页
     *
     * @param pageReqVO 分页查询
     * @return 文件记录分类分页
     */
    PageResult<RecordCategoryDO> getRecordCategoryPage(RecordCategoryPageReqVO pageReqVO);

    List<RecordCategoryDO> getRecordCategoryTree(RecordCategoryPageReqVO pageReqVO);

    RecordCategoryDO selectById(Long categoryId);

    RecordCategoryDO selectCategoryAppraisalDO(Long categoryRootId);

    List<RecordCategoryDO> selectListByCategoryIdIdPath(String recordCategoryDO);
}